<!DOCTYPE html>
<html>
<head>
    <title>Multiple Routes Map</title>
    <style>
        #map {
            height: 600px;
        }
    </style>
    <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyC00igchKfGGaI1L0vCdqmB2_LwawO7jjg"></script>
    <script>
        function initMap() {
            // Define the map options
            var mapOptions = {
                center: {lat: {{ route.start_location.lat }}, lng: {{ route.start_location.lng }} },  // New York City coordinates
                zoom: 12
            };

            // Create the map
            var map = new google.maps.Map(document.getElementById("map"), mapOptions);

            // Define the locations
            var locations = [
                {% for location in waypoints %}
                {name: "{{ location.name }}", lat: {{ location.lat }}, lng: {{ location.lng }}},
                {% endfor %}
            ];

            // Create the markers and info windows
            var markers = [];
            for (var i = 0; i < locations.length; i++) {
                console.log(locations.length)
                var location = locations[i];
                var marker;
                if(i == 0) {
                    marker = new google.maps.Marker({
                        position: {lat: location.lat, lng: location.lng},
                        map: map,
                        icon: {
                            url: "http://maps.google.com/mapfiles/ms/icons/green-dot.png",
                            scaledSize: new google.maps.Size(48, 48)
                        },
                        title: location.name
                    });
                }

                else if(i == locations.length - 1) {
                    marker = new google.maps.Marker({
                        position: {lat: location.lat, lng: location.lng},
                        map: map,
                        icon: {
                            url: "http://maps.google.com/mapfiles/ms/icons/blue-dot.png",
                            scaledSize: new google.maps.Size(48, 48)
                        },
                        title: location.name
                    });
                }
                else{
                    marker = new google.maps.Marker({
                    position: {lat: location.lat, lng: location.lng},
                    map: map,
                    title: location.name
                });
                }
                markers.push(marker);
                var infowindow = new google.maps.InfoWindow({
                    content: location.name
                });
                marker.addListener('click', function() {
                    infowindow.open(map, marker);
                });
            }

            // Create the directions service
            var directionsService = new google.maps.DirectionsService();

            // Generate routes
            var delayFactor = 0;

            // Generate routes
            function map_run() {
                for (var i = 0; i < locations.length - 1; i++) {
                    var origin = locations[i];
                    var destination = locations[i + 1];
                    var request = {
                        origin: new google.maps.LatLng(origin.lat, origin.lng),
                        destination: new google.maps.LatLng(destination.lat, destination.lng),
                        travelMode: 'DRIVING'
                    };
                    directionsService.route(request, function (result, status) {
                        if (status === 'OK') {
                            // Create a polyline for the route
                            var polyline = new google.maps.Polyline({
                                path: result.routes[0].overview_path,
                                strokeColor: '#0000FF',
                                strokeOpacity: 0.8,
                                strokeWeight: 4,
                                map: map
                            });
                        } else if (status === 'OVER_QUERY_LIMIT') {
                            delayFactor++;
                            setTimeout(function () {
                                map_run();
                            }, delayFactor * 2000);
                        }
                    });
                }
            }
            map_run()
        }
    </script>
</head>
<body onload="{
setTimeout(initMap()
, 2000)
}"
>
	<div id="map"></div>
</body>
</html>
